Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package interpreter
  Definition Classes
    nsc
-  class IMain extends Repl with Imports with PresentationCompilation with Closeable

  An interpreter for Scala code.

  An interpreter for Scala code.

  The main public entry points are compile(), interpret(), and bind(). The compile() method loads a complete Scala file. The interpret() method executes one line of Scala code at the request of the user. The bind() method binds an object to a variable that can then be used by later interpreted code.

  The overall approach is based on compiling the requested code and then using a Java classloader and Java reflection to run the code and access its results.

  In more detail, a single compiler instance is used to accumulate all successfully compiled or interpreted Scala code. To "interpret" a line of code, the compiler generates a fresh object that includes the line of code and which has public member(s) to export all variables defined by that code. To extract the result of an interpreted line to show the user, a second "result object" is created which imports the variables exported by the above object and then exports members called "$eval" and "$print". To accommodate user expressions that read from variables or methods defined in previous statements, "import" statements are used.

  This interpreter shares the strengths and weaknesses of using the full compiler-to-Java. The main strength is that interpreted code behaves exactly as does compiled code, including running at full speed. The main weakness is that redefining classes and methods is not handled properly, because rebinding at the Java level is technically difficult.

  Definition Classes
    interpreter
- ComputedImports
- PhaseDependentOps
- PresentationCompileResult
- ReadEvalPrint
- ReplTypeOps
- Request
- deconstruct
- exprTyper
- flatOp
- naming
- replOutput
- typerOp

c

scala.tools.nsc.interpreter.IMain

# ReadEvalPrint

###

#### class ReadEvalPrint extends AnyRef

Here is where we:

1) Read some source code, and put it in the "read" object. 2) Evaluate the read object, and put the result in the "eval" object. 3) Create a String for human consumption, and put it in the "print" object.

Read! Eval! Print! Some of that not yet centralized here.

Source
  IMain.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ReadEvalPrint
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new ReadEvalPrint()
2.  new ReadEvalPrint(lineId: Int)

### Type Members

1.  class EvalException extends RuntimeException

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ReadEvalPrint toany2stringadd[ReadEvalPrint] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ReadEvalPrint, B)
   Implicit
     This member is added by an implicit conversion from ReadEvalPrint toArrowAssoc[ReadEvalPrint] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def bindError(t: Throwable): String
8.  def call(name: String, args: Any*): AnyRef
9.  def callEither(name: String, args: Any*): Either[Throwable, AnyRef]
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
11.  def compile(unit: Global.CompilationUnit): Boolean
12.  def compile(code: String): Boolean
13.  def ensuring(cond: (ReadEvalPrint) => Boolean, msg: => Any): ReadEvalPrint
    Implicit
      This member is added by an implicit conversion from ReadEvalPrint toEnsuring[ReadEvalPrint] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: (ReadEvalPrint) => Boolean): ReadEvalPrint
    Implicit
      This member is added by an implicit conversion from ReadEvalPrint toEnsuring[ReadEvalPrint] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean, msg: => Any): ReadEvalPrint
    Implicit
      This member is added by an implicit conversion from ReadEvalPrint toEnsuring[ReadEvalPrint] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean): ReadEvalPrint
    Implicit
      This member is added by an implicit conversion from ReadEvalPrint toEnsuring[ReadEvalPrint] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
18.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
19.  lazy val evalClass: Class[_]
20.  def evalEither: Either[Throwable, AnyRef]
21.  val evalName: String
22.  def evalPath: String
23.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
24.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ReadEvalPrint toStringFormat[ReadEvalPrint] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
25.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
26.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
27.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
28.  val lineId: Int
29.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
30.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
31.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
32.  def packageDecl: String
33.  val packageName: String
34.  def packaged(code: String): String
35.  def pathTo(name: String): String
36.  def pathToInstance(name: String): String
37.  val printName: String
38.  val readName: String
39.  def readPath: String
40.  def readPathInstance: String
41.  def resolvePathToSymbol(fullAccessPath: String): Global.Symbol

    The innermost object inside the wrapper, found by following accessPath into the outer one.

42.  val resultName: String
43.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
44.  def toString(): String
    Definition Classes
      AnyRef → Any
45.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
46.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
47.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (ReadEvalPrint, B)
   Implicit
     This member is added by an implicit conversion from ReadEvalPrint toArrowAssoc[ReadEvalPrint] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromReadEvalPrint to any2stringadd[ReadEvalPrint]

### Inherited by implicit conversion StringFormat fromReadEvalPrint to StringFormat[ReadEvalPrint]

### Inherited by implicit conversion Ensuring fromReadEvalPrint to Ensuring[ReadEvalPrint]

### Inherited by implicit conversion ArrowAssoc fromReadEvalPrint to ArrowAssoc[ReadEvalPrint]

### Ungrouped